## stress-ng 0.07.28

=== Makefile ===
#
# Copyright (C) 2013-2017 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.07.28
#
# Codename "systematic stress inducer"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
LDFLAGS += -static
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1

#
#  Stressors
#
STRESS_SRC = \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aio-linux.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cap.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dentry.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-fallocate.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-fanotify.c \
	stress-fork.c \
	stress-fp-error.c \
	stress-fstat.c \
	stress-full.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-handle.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-inotify.c \
	stress-iomix.c \
	stress-ioprio.c \
	stress-iosync.c \
	stress-itimer.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-lease.c \
	stress-lsearch.c \
	stress-link.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mmap.c \
	stress-mmapfork.c \
	stress-mmapmany.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-mq.c \
	stress-netlink-proc.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-personality.c \
	stress-pipe.c \
	stress-poll.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-remap-file-pages.c \
	stress-rename.c \
	stress-resources.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigpending.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigq.c \
	stress-sleep.c \
	stress-socket.c \
	stress-socket-fd.c \
	stress-socketpair.c \
	stress-spawn.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-sysinfo.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-unshare.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-utime.c \
	stress-vecmath.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-rw.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-wcstr.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	affinity.c \
	cache.c \
	helper.c \
	ignite-cpu.c \
	io-priority.c \
	limit.c \
	log.c \
	madvise.c \
	mincore.c \
	mlock.c \
	mmap.c \
	mounts.c \
	mwc.c \
	net.c \
	out-of-memory.c \
	parse-opts.c \
	perf.c \
	sched.c \
	shim.c \
	thermal-zone.c \
	time.c \
	thrash.c \
	stress-ng.c

SRC = $(STRESS_SRC) $(CORE_SRC)
OBJS = $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

LIB_APPARMOR := -lapparmor
LIB_BSD := -lbsd
LIB_Z := -lz
LIB_CRYPT := -lcrypt
LIB_RT := -lrt
LIB_PTHREAD := -lpthread
LIB_AIO = -laio
LIB_SCTP = -lsctp

HAVE_NOT=HAVE_APPARMOR=0 HAVE_KEYUTILS_H=0 HAVE_XATTR_H=0 HAVE_LIB_BSD=0 \
	 HAVE_LIB_Z=0 HAVE_LIB_CRYPT=0 HAVE_LIB_RT=0 HAVE_LIB_PTHREAD=0 \
	 HAVE_FLOAT_DECIMAL=0 HAVE_SECCOMP_H=0 HAVE_LIB_AIO=0 HAVE_SYS_CAP_H=0 \
	 HAVE_VECMATH=0 HAVE_ATOMIC=0 HAVE_LIB_SCTP=0 HAVE_ASM_NOP=0 \
	 HAVE_ALIGNED_64K=0 HAVE_ALIGNED_64=0

#
#  Load in current config; use 'make clean' to clear this
#
-include config

CFLAGS += $(CONFIG_CFLAGS)
LDFLAGS += $(CONFIG_LDFLAGS)
OBJS += $(CONFIG_OBJS)

HAVE_VARS := $(foreach h,$(HAVE_NOT), $(firstword $(subst =, ,$h)))

ifeq "$(MAKECMDGOALS)" ""
NEED_CONFIG=1
else ifeq "$(findstring $(MAKECMDGOALS),clean dist install pdf)" ""
NEED_CONFIG=1
endif

#
#  Determine the system build config
#
ifndef HAVE_CONFIG
ifdef NEED_CONFIG
HAVE_CONFIG=1
#
# A bit recursive, 2nd time around HAVE_APPARMOR is
# defined so we don't call ourselves over and over
#
ifeq ($(shell uname -s),SunOS)
	CONFIG_LDFLAGS += -lsocket -lnsl
endif

ifndef $(HAVE_APPARMOR)
HAVE_APPARMOR = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_apparmor)
ifeq ($(HAVE_APPARMOR),1)
	CONFIG_OBJS += apparmor-data.o
	CONFIG_CFLAGS += -DHAVE_APPARMOR
	CONFIG_LDFLAGS += $(LIB_APPARMOR)
$(info autoconfig: using $(LIB_APPARMOR))
endif
endif

ifndef $(HAVE_LIB_BSD)
HAVE_LIB_BSD = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_bsd)
ifeq ($(HAVE_LIB_BSD),1)
	CONFIG_CFLAGS += -DHAVE_LIB_BSD
	CONFIG_LDFLAGS += $(LIB_BSD)
$(info autoconfig: using $(LIB_BSD))
endif
endif

ifndef $(HAVE_LIB_Z)
HAVE_LIB_Z = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_z)
ifeq ($(HAVE_LIB_Z),1)
	CONFIG_CFLAGS += -DHAVE_LIB_Z
	CONFIG_LDFLAGS += $(LIB_Z)
$(info autoconfig: using $(LIB_Z))
endif
endif

ifndef $(HAVE_LIB_CRYPT)
HAVE_LIB_CRYPT = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_crypt)
ifeq ($(HAVE_LIB_CRYPT),1)
	CONFIG_CFLAGS += -DHAVE_LIB_CRYPT
	CONFIG_LDFLAGS += $(LIB_CRYPT)
$(info autoconfig: using $(LIB_CRYPT))
endif
endif

ifndef $(HAVE_LIB_RT)
HAVE_LIB_RT = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_rt)
ifeq ($(HAVE_LIB_RT),1)
	CONFIG_CFLAGS += -DHAVE_LIB_RT
	CONFIG_LDFLAGS += $(LIB_RT)
$(info autoconfig: using $(LIB_RT))
endif
endif

ifndef $(HAVE_LIB_PTHREAD)
HAVE_LIB_PTHREAD = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_pthread)
ifeq ($(HAVE_LIB_PTHREAD),1)
	CONFIG_CFLAGS += -DHAVE_LIB_PTHREAD
	CONFIG_LDFLAGS += $(LIB_PTHREAD)
$(info autoconfig: using $(LIB_PTHREAD))
endif
endif

ifndef $(HAVE_LIB_SCTP)
HAVE_LIB_SCTP = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_sctp)
ifeq ($(HAVE_LIB_SCTP),1)
	CONFIG_CFLAGS += -DHAVE_LIB_SCTP
	CONFIG_LDFLAGS += $(LIB_SCTP)
$(info autoconfig: using $(LIB_SCTP))
endif
endif

ifndef $(HAVE_LIB_AIO)
HAVE_LIB_AIO = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_aio)
ifeq ($(HAVE_LIB_AIO),1)
	CONFIG_CFLAGS += -DHAVE_LIB_AIO
	CONFIG_LDFLAGS += $(LIB_AIO)
$(info autoconfig: using $(LIB_AIO))
endif
endif

ifndef $(HAVE_KEYUTILS_H)
HAVE_KEYUTILS_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_keyutils_h)
ifeq ($(HAVE_KEYUTILS_H),1)
	CONFIG_CFLAGS += -DHAVE_KEYUTILS_H
$(info autoconfig: using keyutils.h)
endif
endif

ifndef $(HAVE_XATTR_H)
HAVE_XATTR_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_xattr_h)
ifeq ($(HAVE_XATTR_H),1)
	CONFIG_CFLAGS += -DHAVE_XATTR_H
$(info autoconfig: using attr/xattr.h)
endif
endif

ifndef $(HAVE_SECCOMP_H)
HAVE_SECCOMP_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_seccomp_h)
ifeq ($(HAVE_SECCOMP_H),1)
	CONFIG_CFLAGS += -DHAVE_SECCOMP_H
$(info autoconfig: using linux/seccomp.h)
endif
endif

ifndef $(HAVE_SYS_CAP_H)
HAVE_SYS_CAP_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_sys_cap_h)
ifeq ($(HAVE_SYS_CAP_H),1)
	CONFIG_CFLAGS += -DHAVE_SYS_CAP_H
$(info autoconfig: using sys/capability.h)
endif
endif

ifndef $(HAVE_FLOAT_DECIMAL)
HAVE_FLOAT_DECIMAL = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_float_decimal)
ifeq ($(HAVE_FLOAT_DECIMAL),1)
	CONFIG_CFLAGS += -DHAVE_FLOAT_DECIMAL
$(info autoconfig: using float decimal support)
endif
endif

ifndef $(HAVE_VECMATH)
HAVE_VECMATH = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_vecmath)
ifeq ($(HAVE_VECMATH),1)
	CONFIG_CFLAGS += -DHAVE_VECMATH
$(info autoconfig: using vector math support)
endif
endif

ifndef $(HAVE_ATOMIC)
HAVE_ATOMIC = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_atomic)
ifeq ($(HAVE_ATOMIC),1)
	CONFIG_CFLAGS += -DHAVE_ATOMIC
$(info autoconfig: using atomic support)
endif
endif

ifndef $(HAVE_ASM_NOP)
HAVE_ASM_NOP = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_asm_nop)
ifeq ($(HAVE_ASM_NOP),1)
	CONFIG_CFLAGS += -DHAVE_ASM_NOP
$(info autoconfig: using nop assembler instruction)
endif
endif

ifndef $(HAVE_ALIGNED_64)
HAVE_ALIGNED_64 = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_aligned_64)
ifeq ($(HAVE_ALIGNED_64),1)
	CONFIG_CFLAGS += -DHAVE_ALIGNED_64
$(info autoconfig: using 64 byte alignment attribute)
endif
endif

ifndef $(HAVE_ALIGNED_64K)
HAVE_ALIGNED_64K = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_aligned_64K)
ifeq ($(HAVE_ALIGNED_64K),1)
	CONFIG_CFLAGS += -DHAVE_ALIGNED_64K
$(info autoconfig: using 64K byte alignment attribute)
endif
endif

endif
endif


.SUFFIXES: .c .o

.o: stress-ng.h Makefile

.c.o: stress-ng.h Makefile $(SRC)
	@echo $(CC) $(CFLAGS) -c -o $@ $<
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: save_config $(OBJS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -lc -o $@

#
#  save configuration
#
.PHONY: save_config
save_config:
	@echo $(foreach h,$(HAVE_VARS),$h=$($(h))) | tr ' ' '\n' > config
	@echo CONFIG_CFLAGS=$(CONFIG_CFLAGS) >> config
	@echo CONFIG_LDFLAGS=$(CONFIG_LDFLAGS) >> config
	@echo CONFIG_OBJS=$(CONFIG_OBJS) >> config
	@echo HAVE_CONFIG=1 >> config

#
#  check if we can build against AppArmor
#
.PHONY: have_apparmor
have_apparmor:
	@$(CC) $(CPPFLAGS) test-apparmor.c $(LIB_APPARMOR) -o test-apparmor 2> /dev/null || true
	@if [ -f test-apparmor ]; then \
		if [ -x "$(APPARMOR_PARSER)" ]; then \
			echo 1 ;\
		else \
			echo 0 ;\
		fi \
	else \
		echo 0 ;\
	fi
	@rm -f test-apparmor

#
#  check if we have keyutils.h
#
.PHONY: have_keyutils_h
have_keyutils_h:
	@echo "#include <sys/types.h>" > test-key.c
	@echo "#include <keyutils.h>" >> test-key.c
	@$(CC) $(CPPFLAGS) -c -o test-key.o test-key.c 2> /dev/null || true
	@if [ -f test-key.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-key.c test-key.o

#
#  check if we have xattr.h
#
.PHONY: have_xattr_h
have_xattr_h:
	@echo "#include <sys/types.h>" > test-xattr.c
	@echo "#include <attr/xattr.h>" >> test-xattr.c
	@$(CC) $(CPPFLAGS) -c -o test-xattr.o test-xattr.c 2> /dev/null || true
	@if [ -f test-xattr.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-xattr.c test-xattr.o

#
#  check if we can build against libbsd
#
.PHONY: have_lib_bsd
have_lib_bsd:

=== debian/changelog ===
stress-ng (0.07.28-1ubuntu1) zesty; urgency=medium

  * Fix vm stressor random errors caused by bug in reseeding (LP: #1681503)
    - on a reseed, the number generator for 8 and 16 bit values was not
      flushing internal state causing mwc8() and mwc16() returning bogus
      values.

 -- Colin King <colin.king@canonical.com>  Tue, 11 Apr 2017 10:27:11 +0100

stress-ng (0.07.28-1) unstable; urgency=medium

  * Makefile: bump version
  * shim: voidify flags argument to shim_mlockall
  * stress-mlock: forgot to use shim_mlockall rather than mlockall
  * stress-mlock: use munlockall/mlockall shims, rename mlock_shim to do_mlock
  * shim: add shims for mlockall and munlock all
  * mwc: optimize 8 and 16 bit mwc functions (LP: #1677645)
  * stress-ng.h: remove unused macro STRESS_IONICE
  * Clean up some formatting of macros and long lines
  * rename type stress_op to stress_op_t
  * rename type stress_id  to stress_id_t
  * stress-ng.h: rename type stress_func to stress_func_t
  * stress-cpu: verify idct method more efficiently
  * Add autoconfig test for 64 byte alignment too
  * Fix test for 64K alignment (instead of 64 byte)
  * Makefile: add missing .PHONY and correct spelling of .PHONEY
  * Add autodetection for 64 byte alignment of functions (LP: #1676834)
  * stress-rmap: use shim fallocated rather than posix_fallocate
  * Makefile: no need to make configuration when making pdf

 -- Colin King <colin.king@canonical.com>  Thu, 30 Mar 2017 17:26:17 +0100

stress-ng (0.07.27-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: Add TODO list to make dist rule
  * manual: update date
  * stress-pty: don't conditionally build out stress_set_pty_max
  * Update TODO list
  * stress-memfd: use correct printf format specifier for uint64_t type
  * stress-chdir, stress-dir: remove unused static flags
  * stress-socket-fd: remove unused macro MAX_FDS
  * stress-memfd: fix comment
  * stress-chdir: correct the chdir-dirs option name
  * stress-chdir: set default to correct DEFAULT_CHDIR_DIRS
  * Add missing control for 4 stressors: (LP: #1676419)
  * - Add --pty-max option to specify max number of ptys to try to open
  * - Add --memfd-fds option to specify the number of memory file descriptors
  * - Add --dir-dirs option to specify number of directories to stress on
  * - Add --chdir-dirs option to specify number of directories
  * log: add some more comments
  * ignite-cpu: add some more minor comments
  * helper: add some more comments
  * stress-ng: add some more comments
  * stress-ng: remove some blank lines
  * mlock: remove const from m_addr_start to fix clang warning
  * stress-fanotify: remove const from metadata declaration
  * stress-cpu: remove unnecessary packed attribute on a union
  * rename optarg args to opt as these shadow the global oparg variable
  * fix up incorrect args to various stressors
  * net: make stress_set_sockaddr_port net_addr const
  * Minor layout re-formatting of long_options table
  * stress-ng: Set per stressor default settings using stressor_set_defaults
  * Manual: update copyright year
  * Add TODO list
  * stress-chroot: fix typo, ENODIR -> ENOTDIR
  * stress-vecmath: remove -O3 optimisation as this breaks gcc on ppc64el
  * Remove PEDANTIC=1 from makefile

 -- Colin King <colin.king@canonical.com>  Mon, 27 Mar 2017 13:49:11 +0000

stress-ng (0.07.26-1) unstable; urgency=medium

  * Makefile: bump version
  * fast-test-all: revert back to maximum of 4 stressors
  * stress-zero: disable write to /dev/zero for minix
  * shim: fix build error and warnings on Minix builds
  * stress-fstat: allow threadless builds for systems without pthreads
  * stress-ng: fix cppcheck style warnings: reduce scope of variables i and j
  * stress-fstat: reduce scope of variable fd
  * stress-zlib: clean up cppcheck style warnings
  * stress-stackmmap: clean up cppcheck style warning
  * stress-bind-mount: use args_t wrapper for clone to fix warning
  * Wrap const *args_t to pass non const void * arg to pthread_create
  * stress-tmpfs: constify array mmap_flags[]
  * stress-shm-sysv: constify array shm_flags[]
  * stress-opcode: constify static array sigs[]
  * stress-mmap: constify mmap_flags
  * stress-af-alg: constify static data structures
  * test-asm-nop: add copyright boiler plate message
  * Make default cache size information debug only
  * thrash: add some function comments
  * shim: add more comments
  * Use the mincore shim to hide BSD/linux 3rd argument differences
  * Add shim for mincore(2)
  * shim: madvise: map madvise advice to posix_madvise advice
  * stressors: use shim_madvise rather than madvise
  * Add shim for madvise(2)
  * stress-fp-error: check for EDOM, ERANGE (LP: #1674000)
  * Make FORCE_DO_NOTHING build in a nop before other ways of doing nothing
  * stress-matrix: align matrices to 64 bytes to reduce cache stalls
  * stress-matrix: use restrict on arrays for more compute
  * stress-icache: add missing support for PPC64
  * Add ppc64 arch to defined STRESS arch types
  * stress-icache: add missing support for IBM s390
  * Add s390 arch to defined STRESS arch types
  * stress-icache: don't build in 64K page support for ARMEL
  * Makefile: replace 'got' with 'using' in autoconfiguration text
  * stress-getrandom: check for EINTR failures (from SIGALRM)
  * Makefile: generate apparmor raw binary data silently
  * Explicitly call pr_closelog() and flush pending output (Closes: #857942)

 -- Colin King <colin.king@canonical.com>  Mon, 20 Mar 2017 10:32:35 +0000

stress-ng (0.07.25-1) unstable; urgency=medium

  * Makefile: bump version
  * helper: avoid calling sched_cpu on ppc64le
  * Makefile: remove NOTPARALLEL, it's not helpful
  * fast-test-all: remove xattr as it can break some file systems
  * Makefile: don't autoconfig if we are making dist clean or install
  * stress-mlock: add in const to void when calling mlock
  * stress-icache: unconstify page_addr to clean up build warnings


## stress-ng 0.08.16

=== Makefile ===
--- 
+++ 
@@ -16,9 +16,9 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.07.28
-#
-# Codename "systematic stress inducer"
+VERSION=0.08.16
+#
+# Codename "harmful hardware harasser"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99
@@ -38,10 +38,12 @@
 #
 ifeq ($(STATIC),1)
 LDFLAGS += -static
+CFLAGS += -DBUILD_STATIC
 endif
 
 BINDIR=/usr/bin
 MANDIR=/usr/share/man/man1
+JOBDIR=/usr/share/stress-ng/example-jobs
 
 #
 #  Stressors
@@ -55,6 +57,7 @@
 	stress-atomic.c \
 	stress-bigheap.c \
 	stress-bind-mount.c \
+	stress-branch.c \
 	stress-brk.c \
 	stress-bsearch.c \
 	stress-cache.c \
@@ -70,9 +73,11 @@
 	stress-cpu.c \
 	stress-cpu-online.c \
 	stress-crypt.c \
+	stress-cyclic.c \
 	stress-daemon.c \
 	stress-dccp.c \
 	stress-dentry.c \
+	stress-dev.c \
 	stress-dir.c \
 	stress-dirdeep.c \
 	stress-dnotify.c \
@@ -102,6 +107,7 @@
 	stress-hsearch.c \
 	stress-icache.c \
 	stress-icmp-flood.c \
+	stress-inode-flags.c \
 	stress-inotify.c \
 	stress-iomix.c \
 	stress-ioprio.c \
@@ -125,6 +131,8 @@
 	stress-membarrier.c \
 	stress-memcpy.c \
 	stress-memfd.c \
+	stress-memrate.c \
+	stress-memthrash.c \
 	stress-mergesort.c \
 	stress-mincore.c \
 	stress-mknod.c \
@@ -136,6 +144,7 @@
 	stress-msg.c \
 	stress-msync.c \
 	stress-mq.c \
+	stress-netdev.c \
 	stress-netlink-proc.c \
 	stress-nice.c \
 	stress-nop.c \
@@ -153,6 +162,7 @@
 	stress-pty.c \
 	stress-quota.c \
 	stress-qsort.c \
+	stress-radixsort.c \
 	stress-rdrand.c \
 	stress-readahead.c \
 	stress-remap-file-pages.c \
@@ -179,14 +189,17 @@
 	stress-sigq.c \
 	stress-sleep.c \
 	stress-socket.c \
+	stress-socket-diag.c \
 	stress-socket-fd.c \
 	stress-socketpair.c \
+	stress-softlockup.c \
 	stress-spawn.c \
 	stress-splice.c \
 	stress-stack.c \
 	stress-stackmmap.c \
 	stress-str.c \
 	stress-stream.c \
+	stress-swap.c \
 	stress-switch.c \
 	stress-sync-file.c \
 	stress-sysinfo.c \
@@ -226,6 +239,7 @@
 	helper.c \
 	ignite-cpu.c \
 	io-priority.c \
+	job.c \
 	limit.c \
 	log.c \
 	madvise.c \
@@ -239,6 +253,7 @@
 	parse-opts.c \
 	perf.c \
 	sched.c \
+	setting.c \
 	shim.c \
 	thermal-zone.c \
 	time.c \
@@ -263,7 +278,10 @@
 	 HAVE_LIB_Z=0 HAVE_LIB_CRYPT=0 HAVE_LIB_RT=0 HAVE_LIB_PTHREAD=0 \
 	 HAVE_FLOAT_DECIMAL=0 HAVE_SECCOMP_H=0 HAVE_LIB_AIO=0 HAVE_SYS_CAP_H=0 \
 	 HAVE_VECMATH=0 HAVE_ATOMIC=0 HAVE_LIB_SCTP=0 HAVE_ASM_NOP=0 \
-	 HAVE_ALIGNED_64K=0 HAVE_ALIGNED_64=0
+	 HAVE_ALIGNED_64K=0 HAVE_ALIGNED_64=0 HAVE_ALIGNED_128=0 \
+	 HAVE_AFFINITY=0 HAVE_MADVISE=0 HAVE_SEM_POSIX=0 HAVE_SEM_SYSV=0 \
+	 HAVE_MQ_POSIX=0 HAVE_MQ_SYSV=0 HAVE_SHM_SYSV=0 HAVE_FANOTIFY=0 \
+	 HAVE_INOTIFY=0 HAVE_SOCK_DIAG_H=0
 
 #
 #  Load in current config; use 'make clean' to clear this
@@ -401,6 +419,14 @@
 endif
 endif
 
+ifndef $(HAVE_SOCK_DIAG_H)
+HAVE_SOCK_DIAG_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_sock_diag_h)
+ifeq ($(HAVE_SOCK_DIAG_H),1)
+	CONFIG_CFLAGS += -DHAVE_SOCK_DIAG_H
+$(info autoconfig: using linux/sock_diag.h)
+endif
+endif
+
 ifndef $(HAVE_FLOAT_DECIMAL)
 HAVE_FLOAT_DECIMAL = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_float_decimal)
 ifeq ($(HAVE_FLOAT_DECIMAL),1)
@@ -441,6 +467,14 @@
 endif
 endif
 
+ifndef $(HAVE_ALIGNED_128)
+HAVE_ALIGNED_128 = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_aligned_128)
+ifeq ($(HAVE_ALIGNED_128),1)
+	CONFIG_CFLAGS += -DHAVE_ALIGNED_128
+$(info autoconfig: using 128 byte alignment attribute)
+endif
+endif
+
 ifndef $(HAVE_ALIGNED_64K)
 HAVE_ALIGNED_64K = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_aligned_64K)
 ifeq ($(HAVE_ALIGNED_64K),1)
@@ -449,81 +483,28 @@
 endif
 endif
 
-endif
-endif
-
-
-.SUFFIXES: .c .o
-
-.o: stress-ng.h Makefile
-
-.c.o: stress-ng.h Makefile $(SRC)
-	@echo $(CC) $(CFLAGS) -c -o $@ $<
-	@$(CC) $(CFLAGS) -c -o $@ $<
-
-stress-ng: save_config $(OBJS)
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -lc -o $@
-
-#
-#  save configuration
-#
-.PHONY: save_config
-save_config:
-	@echo $(foreach h,$(HAVE_VARS),$h=$($(h))) | tr ' ' '\n' > config
-	@echo CONFIG_CFLAGS=$(CONFIG_CFLAGS) >> config
-	@echo CONFIG_LDFLAGS=$(CONFIG_LDFLAGS) >> config
-	@echo CONFIG_OBJS=$(CONFIG_OBJS) >> config
-	@echo HAVE_CONFIG=1 >> config
-
-#
-#  check if we can build against AppArmor
-#
-.PHONY: have_apparmor
-have_apparmor:
-	@$(CC) $(CPPFLAGS) test-apparmor.c $(LIB_APPARMOR) -o test-apparmor 2> /dev/null || true
-	@if [ -f test-apparmor ]; then \
-		if [ -x "$(APPARMOR_PARSER)" ]; then \
-			echo 1 ;\
-		else \
-			echo 0 ;\
-		fi \
-	else \
-		echo 0 ;\
-	fi
-	@rm -f test-apparmor
-
-#
-#  check if we have keyutils.h
-#
-.PHONY: have_keyutils_h
-have_keyutils_h:
-	@echo "#include <sys/types.h>" > test-key.c
-	@echo "#include <keyutils.h>" >> test-key.c
-	@$(CC) $(CPPFLAGS) -c -o test-key.o test-key.c 2> /dev/null || true
-	@if [ -f test-key.o ]; then \
-		echo 1 ;\
-	else \
-		echo 0 ;\
-	fi
-	@rm -f test-key.c test-key.o
-
-#
-#  check if we have xattr.h
-#
-.PHONY: have_xattr_h
-have_xattr_h:
-	@echo "#include <sys/types.h>" > test-xattr.c
-	@echo "#include <attr/xattr.h>" >> test-xattr.c
-	@$(CC) $(CPPFLAGS) -c -o test-xattr.o test-xattr.c 2> /dev/null || true
-	@if [ -f test-xattr.o ]; then \
-		echo 1 ;\
-	else \
-		echo 0 ;\
-	fi
-	@rm -f test-xattr.c test-xattr.o
-
-#
-#  check if we can build against libbsd
-#
-.PHONY: have_lib_bsd
-have_lib_bsd:
+ifndef $(HAVE_AFFINITY)
+HAVE_AFFINITY = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_affinity)
+ifeq ($(HAVE_AFFINITY),1)
+	CONFIG_CFLAGS += -DHAVE_AFFINITY
+$(info autoconfig: using sched affinity CPU masks)
+endif
+endif
+
+ifndef $(HAVE_MADVISE)
+HAVE_MADVISE = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_madvise)
+ifeq ($(HAVE_MADVISE),1)
+	CONFIG_CFLAGS += -DHAVE_MADVISE
+$(info autoconfig: using madvise)
+endif
+endif
+
+ifndef $(HAVE_SEM_POSIX)
+HAVE_SEM_POSIX = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_sem_posix)
+ifeq ($(HAVE_SEM_POSIX),1)
+	CONFIG_CFLAGS += -DHAVE_SEM_POSIX
+$(info autoconfig: using POSIX semaphores)
+endif
+endif
+
+ifndef $(HAVE_SEM_SYSV)

=== debian/changelog ===
stress-ng (0.08.16-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-aio-linux: automatically scale requests (LP: #1711675)
  * stress-socket-diag: sockdiag_send zero return should be checked
  * stress-socket-diag: sockdiag_send should return 0 on stress test end
  * stress-socket-diag: ensure name is sockdiag and not sock-diag
  * Add swapon/off stressor

 -- Colin King <colin.king@canonical.com>  Thu, 21 Sep 2017 10:17:11 +0100

stress-ng (0.08.15-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update date
  * Abstract a shim for off64_t
  * shim: fix typo, error should be errno
  * stress-opcode: don't use seccomp if SECCOMP_SET_MODE_FILTER is not defined
  * stress-memrate: add volatile in void cast to fix buildw arning
  * stress-socket-diag: constify attr and cast
  * shim: move iopriority shims from io-priority.c to shim.c
  * stress-pthread: fix typo mutx -> mutex
  * Add cpu-online and oom-pipe stressors to the pathological class
  * shim: move shim_sync_file_range from stress-sync-file to shim
  * shim: use __NR_futex instead of SYS_futex in syscall
  * stress-dup: use dup3 shim
  * shim: add shim to dup3
  * stress-mincore: reset random address if it matches previous address
  * syscalls.txt: update
  * stress-clock: add half-baked attempt to set timer
  * helper: remove extraneous and incorrect < 0 after prctl call
  * fix -x exclude option
  * stress-ng: make index size_t type
  * stress-opcode: add seccomp filtering to limit syscalls
  * helper: stress_drop_capabilities: don't allow new privileges
  * Enable SCHED_DEADLINE and rework some abstraction interfaces
  * timers: cast to type of tv fields rather than long long int
  * stress-madvise: add MADV_WIPEONFORK
  * stress-vforkmany: cleanup build warnings on munmap on openindiana
  * stress-memrate: cleanup build warnings on munmap on openindiana
  * stress-matrix: cleanup build warnings on munmap on openindiana
  * temporarily disable SCHED_DEADLINE scheduling

 -- Colin King <colin.king@canonical.com>  Wed, 13 Sep 2017 13:35:59 +0100

stress-ng (0.08.14-1) unstable; urgency=medium

  * Makefile: bump version
  * Update TODO list
  * Add a latin (Lorem Ipsum) random text mode to zlib method
  * test-mq-posix: force failure for GNU/HURD
  * test-mq-posix: fix build failure because of missing <signal.h>
  * stress-resources: clean up warning when POSIX MQs are not available
  * include <sys/uio.h> in stress-ng.h
  * stress-mq: make build depend on HAVE_MQ_POSIX being defined
  * Add branch stressor that exercises process branch prediction
  * stress-memrate: perform oom adjustment in child earlier than allocation
  * test-sock-diag: voidify array unix_diag to work around clang warning
  * stress-kcmp: fix kcmp shim and fully implement KCMP_EPOLL_TFD stressor
  * stress-semaphore: make POSIX semaphores depend on HAVE_SEM_POSIX
  * stress-resources: waste POSIX message queues
  * stress-resources: waste SYSV message queues
  * stress-resources: waste SYSV semaphores

 -- Colin King <colin.king@canonical.com>  Thu, 7 Sep 2017 11:59:01 +0100

stress-ng (0.08.13-1) unstable; urgency=medium

  * stress-rdrand: use 32 bit rdrand for i386
  * stress_drop_capabilities: voidify name to avoid warning
  * Enable 64 bit large file system support by default
  * debian/rules: Add hardening=+all
  * manual: fix several spelling mistakes
  * stress-cpu: fix spelling mistake "assigment" -> "assignment"
  * stress-ng: fix spelling mistake "afer" -> "after"
  * stress-opcode: drop all capabilties so we can't do much
    damage (LP: #1714044)
  * helper: add stress_drop_capabilities to drop all capabilities
  * stress-socket-diag: use new HAVE_SOCK_DIAG_H build time check flag
  * Add sock_diag.h auto configure build time checking
  * Add sockdiag stressor
  * stress-fcntl: fix build failure on SLES11 SP4 (LP: #1709905)
  * stress-cyclic: fix build warning on systems w/o atomic ops
  * stress-softlockup: fix build warning on systems w/o atomic ops

 -- Colin King <colin.king@canonical.com>  Wed, 30 Aug 2017 22:06:11 +0100

stress-ng (0.08.12-1) unstable; urgency=medium

  * Makefile: bump version
  * helper: add more debug to filenames to help debugging
  * stress-inode-flags: fix incorrect path being used on
    directory (LP: #1712857)
  
 -- Colin King <colin.king@canonical.com>  Thu, 24 Aug 2017 16:59:33 +0100

stress-ng (0.08.11-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-zlib: use _start for OpenBSD builds
  * stress-zlib: don't build objcode stress method for sun targets
  * Manual: update date
  * Add objcode zlib stressor method to compress object code data
  * stress-zlib: sort zlib methods by name
  * exit immediately on end of --stressors option
  * stress-inode-flags: remove temp file and directory
  * Fix comment in helper
  * stress-radixsort: fix warning on calloc sizeof
  * Add new inode-flags stressor
  * stress-dev: correct a comment
  * stress-dev: add select and F_GETSIG fcntl calls

 -- Colin King <colin.king@canonical.com>  Tue, 22 Aug 2017 11:11:12 +0100

stress-ng (0.08.10-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-dirdeep: fix warning on unused variable ret on BSD systems
  * Update manual description for the --all option
  * job: allow classes to be run as jobs (LP: #1706970)
  * stress-dirdeep: don't remove directories in main exercise function
  * return EXIT_SUCCESS for class cpu? class command
  * stress-dirdeep: exercise files rather than create/delete
  * manual: fix wording in memthrash table
  * stress-dirdeep: Fix inode accounting, add more -v information feedback
  * Add --dirdeep-inodes option to limit of inodes being consumed:
  * parse-opts: don't allow negative percentages
  * Add stress_get_filesystem_available_inodes to get inode number
  * Add generialized percentage opt parser get_uint64_percent
  * helper: remove debug message from stress_get_filesystem_size


=== debian/control ===
Source: stress-ng
Section: devel
Priority: extra
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 4.0.0
Build-Depends: debhelper (>= 9), zlib1g-dev, libbsd-dev, libattr1-dev, libgcrypt20-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
Homepage: http://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.09.06

=== Makefile ===
#
# Copyright (C) 2013-2017 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.09.06
#
# Codename "harmful hardware harasser"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)
CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
LDFLAGS += -static
CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs

#
#  Stressors
#
STRESS_SRC = \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aio-linux.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cap.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-fork.c \
	stress-fp-error.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-handle.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-iosync.c \
	stress-itimer.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-lease.c \
	stress-lsearch.c \
	stress-link.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-longjmp.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mmap.c \
	stress-mmapfork.c \
	stress-mmapmany.c \
	stress-mmapaddr.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-mq.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-personality.c \
	stress-physpage.c \
	stress-pipe.c \
	stress-poll.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-radixsort.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-remap-file-pages.c \
	stress-rename.c \
	stress-resources.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigpending.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigq.c \
	stress-sleep.c \
	stress-socket.c \
	stress-socket-diag.c \
	stress-socket-fd.c \
	stress-socketpair.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-sysinfo.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-tree.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-unshare.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-utime.c \
	stress-vecmath.c \
	stress-vforkmany.c \
	stress-vm.c \
	stress-vm-rw.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-wcstr.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	affinity.c \
	cache.c \
	helper.c \
	ignite-cpu.c \
	io-priority.c \
	job.c \
	limit.c \
	log.c \
	madvise.c \
	mincore.c \
	mlock.c \
	mmap.c \
	mounts.c \
	mwc.c \
	net.c \
	out-of-memory.c \
	parse-opts.c \
	perf.c \
	sched.c \
	setting.c \
	shim.c \
	thermal-zone.c \
	time.c \
	thrash.c \
	stress-ng.c

SRC = $(STRESS_SRC) $(CORE_SRC)
OBJS = $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

LIB_APPARMOR := -lapparmor
LIB_BSD := -lbsd
LIB_Z := -lz
LIB_CRYPT := -lcrypt
LIB_RT := -lrt
LIB_PTHREAD := -lpthread
LIB_AIO = -laio
LIB_SCTP = -lsctp

#
#  Load in current config; use 'make clean' to clear this
#
-include config
ifneq ("$(wildcard config)","")
.PHONY: all_config
all_config:
	$(MAKE) -f Makefile.config
	$(MAKE) stress-ng
endif

CFLAGS += $(CONFIG_CFLAGS)
LDFLAGS += $(CONFIG_LDFLAGS)
OBJS += $(CONFIG_OBJS)

.SUFFIXES: .c .o

.o: stress-ng.h Makefile

.c.o: stress-ng.h Makefile $(SRC)
	@echo $(CC) $(CFLAGS) -c -o $@ $<
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: $(OBJS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -lc -o $@

#
#  generate apparmor data using minimal core utils tools from apparmor
#  parser output
#
apparmor-data.o: usr.bin.pulseaudio.eg
	@$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
	@echo "#include <stddef.h>" > apparmor-data.c
	@echo "char g_apparmor_data[]= { " >> apparmor-data.c
	@od -tx1 -An -v < apparmor-data.bin | \
		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
		sed '$$ s/.$$//' >> apparmor-data.c
	@echo "};" >> apparmor-data.c
	@echo "const size_t g_apparmor_data_len = sizeof(g_apparmor_data);" >> apparmor-data.c
	$(CC) -c apparmor-data.c -o apparmor-data.o
	@rm -rf apparmor-data.c

#
#  extract the PER_* personality enums
#
personality.h:
	@$(CPP) personality.c | grep -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
	| sed "s/.$$/,/" > personality.h

stress-personality.c: personality.h

perf.o: perf.c perf-event.c
	@gcc -E perf-event.c | grep "PERF_COUNT" | sed 's/,/ /' | awk {'print "#define _SNG_" $$1 " (1)"'} > perf-event.h
	@echo $(CC) $(CFLAGS) -c -o $@ $<
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-vecmath.o: stress-vecmath.c
	@echo $(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
	@touch stress-ng.c

$(OBJS): stress-ng.h Makefile

stress-ng.1.gz: stress-ng.1
	gzip -c $< > $@

.PHONY: dist
dist:
	rm -rf stress-ng-$(VERSION)
	mkdir stress-ng-$(VERSION)
	cp -rp Makefile Makefile.config $(SRC) stress-ng.h stress-ng.1 \
		personality.c COPYING syscalls.txt mascot README \
		README.Android test snapcraft smatchify.sh config TODO \
		perf-event.c usr.bin.pulseaudio.eg \
		example-jobs stress-ng-$(VERSION)
	tar -Jcf stress-ng-$(VERSION).tar.xz stress-ng-$(VERSION)
	rm -rf stress-ng-$(VERSION)

.PHONY: pdf
pdf:
	man -t ./stress-ng.1 | ps2pdf - > stress-ng.pdf


.PHONY: clean
clean:
	@rm -f stress-ng $(OBJS) stress-ng.1.gz stress-ng.pdf
	@rm -f stress-ng-$(VERSION).tar.xz
	@rm -f personality.h
	@rm -f perf-event.h
	@rm -f *.o
	@:> config

.PHONY: fast-test-all
fast-test-all: stress-ng
	STRESS_NG=./stress-ng debian/tests/fast-test-all

.PHONY: install
install: stress-ng stress-ng.1.gz
	mkdir -p ${DESTDIR}${BINDIR}
	cp stress-ng ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
	cp stress-ng.1.gz ${DESTDIR}${MANDIR}
	mkdir -p ${DESTDIR}${JOBDIR}
	cp -rp example-jobs/*.job ${DESTDIR}${JOBDIR}

=== debian/changelog ===
stress-ng (0.09.06-1) unstable; urgency=medium

  * Makefile: bump version
  * Add more smarts in autodetecting wcs* functions
  * stress-tree fixes that got discovered after the 0.09.05 release:
    - stress-tree: minor changes to splay and rb tree setup and insertion
    - stress-tree: fix up tree method calling and add AVL tree
  * stress-tree: add binary tree
  * stress-tree: use faster method to populate data

 -- Colin King <colin.king@canonical.com>  Fri, 8 Dec 2017 16:24:56 +0000

stress-ng (0.09.05-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: remove .xz tarball instead of .gz on make clean rule
  * debian/control: update Standards-Version to 4.1.2
  * Debian: watch: change watch URL to use .xz rather than .gz
  * Makefile: use xz compression on tarball make dist rule
  * Manual: Add more information in the tree description
  * stress-wcstr: fix build issues for GNU/kFreeBSD builds
  * Don't include bsd/wchar.h for GNU/kFreeBSD
  * libbsd test: Add *BSD support
  * stress-treee: don't build for __APPLE__
  * Add DragonFly BSD to BSD support for libbsd
  * stress-tree: fix build for systems without libbsd
  * stress-ng: add funccall mini help options.
  * Add libbsd tree stressor
  * test/test-libpthread: remove POSIX semaphore checks
  * stress-ng.h: fix indentation
  * Move put values into global union, saves > 40K on x86
  * Add the funccall function call stressor
  * Makefile: move fanotify stressor to correct alphabetical order place
  * stress-dev: perform open with O_RDONLY | O_WRONLY for ioctl opens
  * stress-clone: catch OOM'ing clone stressors and re-spawn them

 -- Colin King <colin.king@canonical.com>  Wed, 6 Dec 2017 13:20:46 +0000

stress-ng (0.09.04-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update date
  * stress-sigsegv:  catch SIGBUS for systems such as __APPLE__
  * stress-fault: catch SIGBUS for systems such as __APPLE__
  * stress-mmapaddr: cast uint64_t value to intptr_t
  * stress-mmapaddr: set addr correctly, fixes null ptr issue
  * stress-mmapaddr: add mremapping if supported
  * stress-mmapaddr: add MAP_LOCKED random flag setting
  * stress-mmapaddr: 2nd mmap should check remap addr, and add MAP_32BIT
  * stress-mmapaddr: add random MAP_FIXED flag
  * Add stress-mmapaddr random address mmap stressor
  * stress-icache: remove constification of page_addr
  * stress-hrtimes: make a couple functions static
  * stress-vm-rw: constify pointer ctxt
  * stress-vm: add a couple of constifications in macros
  * stress-userfaultfd: constify a couple of function args
  * stress-tmpfs: constify rnd
  * stress-stream: constify advice in struct stream_madvise_info_t
  * stress-socket: constify type in struct socket_type_t
  * stress-pty: fix typo in comment
  * stress-mmapfork: constify ln
  * stress-mknode: constify greycode
  * stress-mincore: remove some empty lines
  * stress-mergesort: reorder statements and int declaration
  * stress-malloc: add some constifications
  * stress-ioport: constify flag
  * stress-icache: constify page_addr
  * stress-hdd: add some more constifications
  * stress-full: constify fields of a struct
  * stress-flock: constify ppid
  * stress-filename: add various variable constifications
  * stress-fiemap: add various variable constifications
  * stress-dirdeep: constify inodes_avail
  * stress-dentry: add a constification to a data structure
  * stress-clock: add a few more constifications
  * stress-branch: make array labels const
  * affinity: constify max_cpus
  * Add more comments to stress-ng.h
  * stress-vforkmany: call vfork syscall directly when possible
  * stress-open: only close fd's that have been opened
  * stress-cpu-online: only allow all CPUs to be offlined with 1 instance
  * stress-cpu-online: by default, don't offline/online CPU 0

 -- Colin King <colin.king@canonical.com>  Sun, 26 Nov 2017 22:46:23 +0000

stress-ng (0.09.03-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update date
  * stress-physpage: move unsupported function
  * Add new physpage stressor
  * Manual: add more notes on the OOM behaviour of the stack stressor
  * Add in stressor name or core context as prefix in pr_dbg messages
  * stress-fanotify: write "test" rather than "foo"
  * stress-exec: don't allow this to run as root, skip rather than fail
  * stress-ng: remove semaphore.h, it is in stress-ng.h already
  * stress-hrtimers: don't kill pid 0

 -- Colin King <colin.king@canonical.com>  Sun, 19 Nov 2017 16:01:11 +0000

stress-ng (0.09.02-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update contributors names and date
  * README: update, add OS X instructions and add clean rule
  * shim: cast to int for brk for __APPLE__
  * stress-ng.h: fix missing _ off __APPLE_ macro name
  * Use shim_sbrk and shim_brk wrappers
  * Add shim for brk and sbrk
  * stress-pthread: use shim_sched_yield instead if pthread_yield
  * stress-ng.h: use shim spinlock in warn_once inline helper
  * pthreads: shim spinlocks so we can use mutex if not available
  * Makefile.config: add missing (
  * Make BSD library more flexible, especially with __APPLE__ arch
  * stress-inode-flags: reset flags to zero at end of loop (LP: #1730297)
  * stress-inode-flags: move counter to bump once per loop iteration
  * stress-random: enable random stressor for __APPLE__ arch
  * stress-filename: default to POSIX filename chars for __APPLE__
  * stress-filename: OS X can't have ':' in filenames
  * stress-fcntl: fix up incorrect name of failed system call
  * stress-fcntl: remove need for 2nd fd in F_DUPFD
  * stress-mmap: add MAC OS X mmap flags
  * stress-schedpolicy: disable this for __APPLE__ arch
  * sched: detect __APPLE__ and don't used sched funcs for this arch
  * stress-zlib: correct text start/end for all OS choices
  * test/test-libpthread: ensure we check all pthread functionality
  * Update README.Android notes



=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: stress-ng
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.2
 Build-Depends: debhelper (>= 9), zlib1g-dev, libbsd-dev, libattr1-dev, libgcrypt20-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
 Homepage: http://kernel.ubuntu.com/~cking/stress-ng
